=== debian/changelog ===
glibc (2.41-12) unstable; urgency=medium

  [ Helmut Grohne ]
  * debian/debhelper.in/libc.postinst: Don't restart systemd when it does not
    work.

 -- Aurelien Jarno <aurel32@debian.org>  Tue, 05 Aug 2025 19:34:49 +0200

glibc (2.41-11) unstable; urgency=medium

  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix iconv to not create executable files with -o.
    - Fix double-free after allocation failure in regcomp (GLIBC-SA-2025-0005
      / CVE-2025-8058).  Closes: #1109803.

 -- Aurelien Jarno <aurel32@debian.org>  Sat, 26 Jul 2025 20:29:12 +0200

glibc (2.41-10) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/testsuite-xfail-debian.mk: Update xfails.
  * debian/patches/hurd-i386/local-pthread_once.diff: Pave the way for 2.42.

  [ Helmut Grohne ]
  * Partially restore init restarting. (Closes: #1108193)

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix sparc32 Fix argument passing to __libc_start_main
    - Fix error reporting (false negatives) in SGID tests

 -- Aurelien Jarno <aurel32@debian.org>  Thu, 17 Jul 2025 13:21:32 +0200

glibc (2.41-9) unstable; urgency=medium

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix loading TLS-using modules using LD_AUDIT.
    - Add tests for CVE-2025-4802.
    - Fix swapped wcsncpy and wcpncpy function names in IFUNC definition.
    - Fix elf/tst-execstack-prog-static-tunable on sparc64.
    - Remove POWER10 optimized strcmp function (GLIBC-SA-2025-0003 /
      CVE-2025-5702).  Closes: #1107365.
    - Remove POWER10 optimized strncmp function (GLIBC-SA-2025-0004 /
      CVE-2025-5745).  Closes: #1107366.
    - Remove POWER10 optimized memchr function.

  [ Samuel Thibault ]
  * debian/patches/hurd-i386/git-rename.diff: Make rename refuse trailing
    slashes.
  * debian/patches/hurd-i386/local-64b-align.diff: Avoid 64b typing error on
    RPCs using 64b fields in structures.

 -- Aurelien Jarno <aurel32@debian.org>  Wed, 18 Jun 2025 06:49:31 +0200

glibc (2.41-8) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/testsuite-xfail-debian.mk: xfail tst-execstack-prog-static-tunable
    on hurd-any. Drop duplicate unsupported stances commited uptream.
  * debian/patches/hurd-i386/git-dup-refcnt.diff: Fix detecting too many dups.
  * debian/patches/hurd-i386/git-xstate.diff: Fix restoring SSE state on
    signals.
  * debian/patches/hurd-i386/local-intr-msg-clobber.diff: Drop now-useless
    patch.
  * debian/patches/hurd-i386/git-utime-EINVAL.diff: Make *utime*s catch invalid
    times.
  * debian/patches/hurd-i386/git-xstate-initialized.diff: Fix crash in dash.
  * debian/patches/hurd-i386/git-signal-fpe-exceptions.diff: Fix crash in FPE
    handlers.
  * debian/patches/hurd-i386/git-symlink-eexist.diff: Fix gnulib testsuite.

  [ Adriano Rafael Gomes ]
  * Update Brazilian Portuguese debconf translation.  Closes: #1103446.

  [ Aurelien Jarno ]
  * debian/rules.d/debhelper.mk: do not replace LIBC in debhelper.in files.
    This was used for lintian overrides, but it is not used anymore.  Closes:
    #1104099.
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix elf/tst-audit10 test failure on x86 systems without AVX.  Closes:
      #1103303.
    - Fix pthread_getattr_np failure when executable stack tunable is set.

 -- Aurelien Jarno <aurel32@debian.org>  Sat, 17 May 2025 17:15:43 +0200

glibc (2.41-7) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/patches/hurd-i386/git-pthread_setcancel.diff: Fix tst-cond32.

  [ Atila KOÇ ]
  * Update Turkish debconf translation.  Closes: #1101162.

  [ Remus-Gabriel Chelu ]
  * Update Romanian debconf translation.  Closes: #1101814.

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Build a FMA version of atanh, sinh and tanh functions using IFUNC on
      amd64.
    - Fix a crash on amd64 when disabling XSAVEC through the glibc.cpu.hwcaps
      tunable.
    - Extend glibc.rtld.execstack tunable to force executable stack.
    - Detect Intel Arrow Lake, Panther Lake, Clearwater Forest, and Diamond
      Rapids CPUs.
    - Handle unknown Intel processors with default tuning.
  * debhelper.in/libc.NEWS: add an entry to describe the executable stack
    change and provide workaround.

 -- Aurelien Jarno <aurel32@debian.org>  Sun, 13 Apr 2025 21:40:49 +0200

glibc (2.41-6) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/rules.d/build.mk: Fix missing library-path to get just-built
    libmachuser and libhurduser.
  * debian/patches/hurd-i386/git-rt-timedwait-realtime.diff: Fix aio_suspend
    delay.

 -- Aurelien Jarno <aurel32@debian.org>  Fri, 14 Mar 2025 23:56:28 +0100

glibc (2.41-5) unstable; urgency=medium

  [ Pedro Ribeiro ]
  * Update Portuguese translation.  Closes: #1100065.

  [ Bjarni Ingi Gislason ]
  * debian/local/manpages/gencat.1: editorial fixes.  Closes: #1100190.

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix race condition between pthread_cancel() and pthread_setcanceltype()
      affecting PARI/GP.  Closes: #1099624.
  * debian/control.in/libc: add more conflicts against shared libraries with
    executable stack.

 -- Aurelien Jarno <aurel32@debian.org>  Fri, 14 Mar 2025 21:07:20 +0100

glibc (2.41-4) unstable; urgency=medium

  [ Aurelien Jarno ]
  * debian/control.in/libc: change breaks against postgresql-15-pllua to the
    fixed version available in apt.postgresql.org.  Closes: #1099197.
  * debian/control.in/libc: add more conflicts against shared libraries with
    executable stack.
  * debian/tests/upstream-testsuite: disable biarch testsuite for i386
    autopkgtest as the i386 debci runners are not powerful to run all the
    testsuites within the default timeout.
  * debian/patches/git-updates.diff: update from upstream stable branch:

