=== debian/tests/control ===
Tests: upstream-testsuite
Depends: @builddeps@, binutils, linux-libc-dev [linux-any], gcc-14
Restrictions: allow-stderr
