=== debian/watch ===
version=4
opts="mode=git, gitmode=shallow, pgpmode=none" \
https://sourceware.org/git/glibc.git refs/tags/glibc-(\d+\.\d+(?:\.\d{1,2})?)$ debian
